diff --minimal -Nru dpkg-cross-2.6.15/config/cross-config.alpha dpkg-cross-2.6.15/config/cross-config.alpha
--- dpkg-cross-2.6.15/config/cross-config.alpha	2019-04-06 07:21:56.000000000 +0200
+++ dpkg-cross-2.6.15/config/cross-config.alpha	2020-06-21 21:29:37.000000000 +0200
@@ -7,19 +7,3 @@
 #
 ac_cv_c_bigendian=no
 ac_cv_c_char_unsigned=no
-ac_cv_sizeof_long_long=8
-ac_cv_sizeof_unsigned_long_long=8
-ac_cv_sizeof_long=8
-ac_cv_sizeof_unsigned_long=8
-ac_cv_sizeof_int=4
-ac_cv_sizeof_unsigned_int=4
-ac_cv_sizeof_short=2
-ac_cv_sizeof_unsigned_short=2
-ac_cv_sizeof_char=1
-ac_cv_sizeof_unsigned_char=1
-ac_cv_sizeof_signed_char=1
-ac_cv_sizeof_float=4
-ac_cv_sizeof_double=8
-ac_cv_sizeof_long_double=8
-ac_cv_sizeof_void_p=8
-ac_cv_sizeof_char_p=8
diff --minimal -Nru dpkg-cross-2.6.15/config/cross-config.amd64 dpkg-cross-2.6.15/config/cross-config.amd64
--- dpkg-cross-2.6.15/config/cross-config.amd64	2019-04-06 07:21:56.000000000 +0200
+++ dpkg-cross-2.6.15/config/cross-config.amd64	2020-06-21 21:29:37.000000000 +0200
@@ -6,16 +6,3 @@
 #
 ac_cv_c_bigendian=no
 ac_cv_c_char_unsigned=no
-ac_cv_sizeof_long_long=8
-ac_cv_sizeof_unsigned_long_long=8
-ac_cv_sizeof_long=8
-ac_cv_sizeof_unsigned_long=8
-ac_cv_sizeof_int=4
-ac_cv_sizeof_unsigned_int=4
-ac_cv_sizeof_short=2
-ac_cv_sizeof_unsigned_short=2
-ac_cv_sizeof_short=2
-ac_cv_sizeof_unsigned_short=2
-ac_cv_sizeof_float=4
-ac_cv_sizeof_double=8
-ac_cv_sizeof_long_double=16
diff --minimal -Nru dpkg-cross-2.6.15/config/cross-config.arm64 dpkg-cross-2.6.15/config/cross-config.arm64
--- dpkg-cross-2.6.15/config/cross-config.arm64	2015-01-22 20:10:23.000000000 +0100
+++ dpkg-cross-2.6.15/config/cross-config.arm64	2020-06-21 21:29:37.000000000 +0200
@@ -6,23 +6,6 @@
 # now ensure the real architecture-dependent values take priority
 ac_cv_c_bigendian=no
 ac_cv_c_char_unsigned=yes
-ac_cv_sizeof_long_long=8
-ac_cv_sizeof_unsigned_long_long=8
-ac_cv_sizeof_long=8
-ac_cv_sizeof_unsigned_long=8
-ac_cv_sizeof_int=4
-ac_cv_sizeof_unsigned_int=4
-ac_cv_sizeof_short=2
-ac_cv_sizeof_unsigned_short=2
-ac_cv_sizeof_char=1
-ac_cv_sizeof_unsigned_char=1
-ac_cv_sizeof_signed_char=1
-ac_cv_sizeof_float=4
-ac_cv_sizeof_double=8
-ac_cv_sizeof_long_double=16
-ac_cv_sizeof_void_p=8
-ac_cv_sizeof_char_p=8
-ac_cv_sizeof_time_t=8
 
 #lots of things: turn off stack protector
 libc_cv_fno_stack_protector=no
@@ -43,7 +26,6 @@
 #Verifed with native test program
 apr_cv_mutex_robust_shared=yes
 #probably more general than just APR. verifed by cross compiling and running test from configure
-ac_cv_sizeof_struct_iovec=16
 
 # mysql
 # mysql wants to know stack direction:
diff --minimal -Nru dpkg-cross-2.6.15/config/cross-config.armel dpkg-cross-2.6.15/config/cross-config.armel
--- dpkg-cross-2.6.15/config/cross-config.armel	2015-01-22 20:17:29.000000000 +0100
+++ dpkg-cross-2.6.15/config/cross-config.armel	2020-06-21 21:29:37.000000000 +0200
@@ -3,22 +3,6 @@
 # now ensure the real architecture-dependent values take priority
 ac_cv_c_bigendian=no
 ac_cv_c_char_unsigned=yes
-ac_cv_sizeof_long_long=8
-ac_cv_sizeof_unsigned_long_long=8
-ac_cv_sizeof_long=4
-ac_cv_sizeof_unsigned_long=4
-ac_cv_sizeof_int=4
-ac_cv_sizeof_unsigned_int=4
-ac_cv_sizeof_short=2
-ac_cv_sizeof_unsigned_short=2
-ac_cv_sizeof_char=1
-ac_cv_sizeof_unsigned_char=1
-ac_cv_sizeof_signed_char=1
-ac_cv_sizeof_float=4
-ac_cv_sizeof_double=8
-ac_cv_sizeof_long_double=8
-ac_cv_sizeof_void_p=4
-ac_cv_sizeof_char_p=4
 
 path=`dirname $ac_site_file`
 # now allow package-specific architecture-independent values to be set
diff --minimal -Nru dpkg-cross-2.6.15/config/cross-config.armhf dpkg-cross-2.6.15/config/cross-config.armhf
--- dpkg-cross-2.6.15/config/cross-config.armhf	2015-01-22 20:16:56.000000000 +0100
+++ dpkg-cross-2.6.15/config/cross-config.armhf	2020-06-21 21:29:37.000000000 +0200
@@ -3,22 +3,6 @@
 # now ensure the real architecture-dependent values take priority
 ac_cv_c_bigendian=no
 ac_cv_c_char_unsigned=yes
-ac_cv_sizeof_long_long=8
-ac_cv_sizeof_unsigned_long_long=8
-ac_cv_sizeof_long=4
-ac_cv_sizeof_unsigned_long=4
-ac_cv_sizeof_int=4
-ac_cv_sizeof_unsigned_int=4
-ac_cv_sizeof_short=2
-ac_cv_sizeof_unsigned_short=2
-ac_cv_sizeof_char=1
-ac_cv_sizeof_unsigned_char=1
-ac_cv_sizeof_signed_char=1
-ac_cv_sizeof_float=4
-ac_cv_sizeof_double=8
-ac_cv_sizeof_long_double=8
-ac_cv_sizeof_void_p=4
-ac_cv_sizeof_char_p=4
 
 path=`dirname $ac_site_file`
 # now allow package-specific architecture-independent values to be set
diff --minimal -Nru dpkg-cross-2.6.15/config/cross-config.cache dpkg-cross-2.6.15/config/cross-config.cache
--- dpkg-cross-2.6.15/config/cross-config.cache	2012-11-24 22:14:14.000000000 +0100
+++ dpkg-cross-2.6.15/config/cross-config.cache	2020-06-21 21:30:02.000000000 +0200
@@ -27,7 +27,6 @@
 apr_cv_epoll_create1=yes
 # apr_cv_process_shared_works: maybe arch specific? 
 # apr_cv_mutex_robust_shared: maybe arch specific?
-# ac_cv_sizeof_struct_iovec: is arch specific
 fi
 
 # avahi
@@ -239,7 +238,6 @@
 # need bespoke /etc/dpkg-cross/cross-config.d/arch:all support.
 if [ "$PACKAGE" = "sqlite" -o "$PACKAGE_NAME" = "sqlite" ]; then
 ac_cv_prog_cc_c89=
-ac_cv_header_readline_h=yes
 lt_cv_path_NM="/usr/bin/nm -B"
 archive_cmds_need_lc=no
 archive_cmds_need_lc_CXX=no
diff --minimal -Nru dpkg-cross-2.6.15/config/cross-config.cygwin-i386 dpkg-cross-2.6.15/config/cross-config.cygwin-i386
--- dpkg-cross-2.6.15/config/cross-config.cygwin-i386	2011-03-27 08:14:10.000000000 +0200
+++ dpkg-cross-2.6.15/config/cross-config.cygwin-i386	2020-06-21 21:29:37.000000000 +0200
@@ -9,8 +9,6 @@
 # host. So supply them manually...
 #
 ac_cv_c_bigendian=no
-ac_cv_sizeof_unsigned_int=4
-ac_cv_sizeof_unsigned_long=4
 
 #ac_cv_header_stdc=yes
 #ac_cv_func_closedir_void=no
diff --minimal -Nru dpkg-cross-2.6.15/config/cross-config.hppa dpkg-cross-2.6.15/config/cross-config.hppa
--- dpkg-cross-2.6.15/config/cross-config.hppa	2019-04-06 07:21:56.000000000 +0200
+++ dpkg-cross-2.6.15/config/cross-config.hppa	2020-06-21 21:29:37.000000000 +0200
@@ -7,19 +7,6 @@
 #
 ac_cv_c_bigendian=yes
 ac_cv_c_char_unsigned=no
-ac_cv_sizeof_long_long=8
-ac_cv_sizeof_unsigned_long_long=8
-ac_cv_sizeof_long=4
-ac_cv_sizeof_unsigned_long=4
-ac_cv_sizeof_int=4
-ac_cv_sizeof_unsigned_int=4
-ac_cv_sizeof_short=2
-ac_cv_sizeof_unsigned_short=2
-ac_cv_sizeof_short=2
-ac_cv_sizeof_unsigned_short=2
-ac_cv_sizeof_float=4
-ac_cv_sizeof_double=8
-ac_cv_sizeof_long_double=12
 
 
 ## bash
diff --minimal -Nru dpkg-cross-2.6.15/config/cross-config.i386 dpkg-cross-2.6.15/config/cross-config.i386
--- dpkg-cross-2.6.15/config/cross-config.i386	2009-02-10 17:51:19.000000000 +0100
+++ dpkg-cross-2.6.15/config/cross-config.i386	2020-06-21 21:29:37.000000000 +0200
@@ -9,19 +9,6 @@
 #
 ac_cv_c_bigendian=no
 ac_cv_c_char_unsigned=no
-ac_cv_sizeof_long_long=8
-ac_cv_sizeof_unsigned_long_long=8
-ac_cv_sizeof_long=4
-ac_cv_sizeof_unsigned_long=4
-ac_cv_sizeof_int=4
-ac_cv_sizeof_unsigned_int=4
-ac_cv_sizeof_short=2
-ac_cv_sizeof_unsigned_short=2
-ac_cv_sizeof_short=2
-ac_cv_sizeof_unsigned_short=2
-ac_cv_sizeof_float=4
-ac_cv_sizeof_double=8
-ac_cv_sizeof_long_double=12
 
 path=`dirname $ac_site_file`
 # now allow package-specific architecture-independent values to be set
diff --minimal -Nru dpkg-cross-2.6.15/config/cross-config.m32r dpkg-cross-2.6.15/config/cross-config.m32r
--- dpkg-cross-2.6.15/config/cross-config.m32r	2015-01-22 20:17:47.000000000 +0100
+++ dpkg-cross-2.6.15/config/cross-config.m32r	2020-06-21 21:29:37.000000000 +0200
@@ -4,21 +4,6 @@
 # m32r specific configure variables
 ac_cv_c_bigendian=yes
 ac_cv_c_char_unsigned=no
-ac_cv_sizeof_char=1
-ac_cv_sizeof_double=8
-ac_cv_sizeof_float=4
-ac_cv_sizeof_int=4
-ac_cv_sizeof_long=4
-ac_cv_sizeof_long_double=12
-ac_cv_sizeof_long_long=8
-ac_cv_sizeof_short=2
-ac_cv_sizeof_signed_char=1
-ac_cv_sizeof_unsigned_int=4
-ac_cv_sizeof_unsigned_long=4
-ac_cv_sizeof_unsigned_long_long=8
-ac_cv_sizeof_unsigned_short=2
-ac_cv_sizeof_unsigned_short=2
-ac_cv_sizeof_void_p=4
 #
 ac_cv_func_setpgrp_void=yes
 ac_cv_prog_cc_cross=yes
diff --minimal -Nru dpkg-cross-2.6.15/config/cross-config.m68k dpkg-cross-2.6.15/config/cross-config.m68k
--- dpkg-cross-2.6.15/config/cross-config.m68k	2019-04-06 07:21:56.000000000 +0200
+++ dpkg-cross-2.6.15/config/cross-config.m68k	2020-06-21 21:29:37.000000000 +0200
@@ -7,16 +7,3 @@
 #
 ac_cv_c_bigendian=yes
 ac_cv_c_char_unsigned=no
-ac_cv_sizeof_long_long=8
-ac_cv_sizeof_unsigned_long_long=8
-ac_cv_sizeof_long=4
-ac_cv_sizeof_unsigned_long=4
-ac_cv_sizeof_int=4
-ac_cv_sizeof_unsigned_int=4
-ac_cv_sizeof_short=2
-ac_cv_sizeof_unsigned_short=2
-ac_cv_sizeof_short=2
-ac_cv_sizeof_unsigned_short=2
-ac_cv_sizeof_float=4
-ac_cv_sizeof_double=8
-ac_cv_sizeof_long_double=12
diff --minimal -Nru dpkg-cross-2.6.15/config/cross-config.mips dpkg-cross-2.6.15/config/cross-config.mips
--- dpkg-cross-2.6.15/config/cross-config.mips	2009-02-10 17:51:19.000000000 +0100
+++ dpkg-cross-2.6.15/config/cross-config.mips	2020-06-21 21:29:37.000000000 +0200
@@ -5,12 +5,6 @@
 #
 ac_cv_c_bigendian=yes
 ac_cv_c_char_unsigned=no
-ac_cv_sizeof_long=4
-ac_cv_sizeof_int=4
-ac_cv_sizeof_char_p=4
-ac_cv_sizeof_long_long=8
-ac_cv_sizeof_unsigned_long=4
-ac_cv_sizeof_unsigned_int=4
 
 path=`dirname $ac_site_file`
 # now allow package-specific architecture-independent values to be set
diff --minimal -Nru dpkg-cross-2.6.15/config/cross-config.mipsel dpkg-cross-2.6.15/config/cross-config.mipsel
--- dpkg-cross-2.6.15/config/cross-config.mipsel	2009-02-10 22:04:18.000000000 +0100
+++ dpkg-cross-2.6.15/config/cross-config.mipsel	2020-06-21 21:29:37.000000000 +0200
@@ -5,12 +5,6 @@
 #
 ac_cv_c_bigendian=no
 ac_cv_c_char_unsigned=no
-ac_cv_sizeof_long=4
-ac_cv_sizeof_int=4
-ac_cv_sizeof_char_p=4
-ac_cv_sizeof_long_long=8
-ac_cv_sizeof_unsigned_long=4
-ac_cv_sizeof_unsigned_int=4
 
 path=`dirname $ac_site_file`
 # now allow package-specific architecture-independent values to be set
diff --minimal -Nru dpkg-cross-2.6.15/config/cross-config.powerpc dpkg-cross-2.6.15/config/cross-config.powerpc
--- dpkg-cross-2.6.15/config/cross-config.powerpc	2009-02-10 17:51:19.000000000 +0100
+++ dpkg-cross-2.6.15/config/cross-config.powerpc	2020-06-21 21:29:37.000000000 +0200
@@ -9,18 +9,6 @@
 #
 ac_cv_c_bigendian=yes
 ac_cv_c_char_unsigned=yes
-ac_cv_sizeof_long_long=8
-ac_cv_sizeof_unsigned_long_long=8
-ac_cv_sizeof_long=4
-ac_cv_sizeof_unsigned_long=4
-ac_cv_sizeof_int=4
-ac_cv_sizeof_unsigned_int=4
-ac_cv_sizeof_short=2
-ac_cv_sizeof_unsigned_short=2
-ac_cv_sizeof_short=2
-ac_cv_sizeof_unsigned_short=2
-ac_cv_sizeof_float=4
-ac_cv_sizeof_double=8
 
 # for glib2.0
 if [ "$PACKAGE" = "glib2.0" -o "$PACKAGE_NAME" = "glib2.0" ]; then
diff --minimal -Nru dpkg-cross-2.6.15/config/cross-config.sh dpkg-cross-2.6.15/config/cross-config.sh
--- dpkg-cross-2.6.15/config/cross-config.sh	2015-01-22 20:18:13.000000000 +0100
+++ dpkg-cross-2.6.15/config/cross-config.sh	2020-06-21 21:29:37.000000000 +0200
@@ -6,21 +6,6 @@
 ac_cv_func_setpgrp_void=yes
 ac_cv_prog_cc_cross=yes
 ac_cv_search_clock_gettime=no
-ac_cv_sizeof_char=1
-ac_cv_sizeof_double=8
-ac_cv_sizeof_float=4
-ac_cv_sizeof_int=4
-ac_cv_sizeof_long=4
-ac_cv_sizeof_long_double=12
-ac_cv_sizeof_long_long=8
-ac_cv_sizeof_short=2
-ac_cv_sizeof_signed_char=1
-ac_cv_sizeof_unsigned_int=4
-ac_cv_sizeof_unsigned_long=4
-ac_cv_sizeof_unsigned_long_long=8
-ac_cv_sizeof_unsigned_short=2
-ac_cv_sizeof_unsigned_short=2
-ac_cv_sizeof_void_p=4
 # DB2, DB3
 db_cv_alignp_t=int
 db_cv_fcntl_f_setfd=yes
diff --minimal -Nru dpkg-cross-2.6.15/debian/changelog dpkg-cross-2.6.15/debian/changelog
--- dpkg-cross-2.6.15/debian/changelog	2019-05-26 23:33:37.000000000 +0200
+++ dpkg-cross-2.6.15/debian/changelog	2020-06-22 05:55:01.000000000 +0200
@@ -1,3 +1,21 @@
+dpkg-cross (2.6.15-3.1) unstable; urgency=medium
+
+  * Non-maintainer upload.
+
+  [ YunQiang Su ]
+  * skip ld.so.1 in /usr/$(multiarch)/lib for mips n32, mips 64 and sparc64
+    (Closes: #881687)
+
+  [ Helmut Grohne ]
+  * Arch qualify dependencies in shlibs files. (Closes: #955631)
+  * Remove all ac_cv_sizeof_* variables. (Closes: #959524)
+    Thanks to Jessica Clarke for identifying the gcc-V FTCBFS cause.
+  * Drop ac_cv_header_readline_h from cross-config.cache. (Closes: #931077)
+  * Update Priority from extra to optional.
+  * Delete dysfunctional Homepage.
+
+ -- Helmut Grohne <helmut@subdivi.de>  Mon, 22 Jun 2020 05:55:01 +0200
+
 dpkg-cross (2.6.15-3) unstable; urgency=medium
 
   [ Helmut Grohne ]
diff --minimal -Nru dpkg-cross-2.6.15/debian/control dpkg-cross-2.6.15/debian/control
--- dpkg-cross-2.6.15/debian/control	2016-10-11 16:11:12.000000000 +0200
+++ dpkg-cross-2.6.15/debian/control	2020-06-22 05:55:01.000000000 +0200
@@ -1,10 +1,9 @@
 Source: dpkg-cross
 Section: utils
-Priority: extra
+Priority: optional
 Maintainer: Wookey <wookey@debian.org>
 Build-Depends: cdbs, debhelper (>> 5)
 Standards-Version: 3.9.8
-Homepage: http://dpkg-cross.alioth.debian.org/
 Vcs-Browser: http://www.emdebian.org/trac/browser/current/host/trunk/dpkg-cross/trunk/
 Vcs-SVN: http://www.emdebian.org/svn/current/host/trunk/dpkg-cross/trunk/
 
diff --minimal -Nru dpkg-cross-2.6.15/dpkg-cross dpkg-cross-2.6.15/dpkg-cross
--- dpkg-cross-2.6.15/dpkg-cross	2017-07-24 17:47:10.000000000 +0200
+++ dpkg-cross-2.6.15/dpkg-cross	2020-06-21 21:28:46.000000000 +0200
@@ -631,6 +631,15 @@
 			return 0;
 		}
 		while (<FROM>) {
+			if ($multiarch =~ m/mips(isa)?64.*-linux.*-gnuabi64.*/) {
+				s:(^|[^-\w/])(/usr)?/lib/${multiarch}ld\.so\.1:$1$crosslib64/ld.so.1:g;
+			} elsif ($multiarch =~ m/^mips(isa)?64.*-linux.*-gnuabin32.*/) {
+				s:(^|[^-\w/])(/usr)?/lib/${multiarch}ld\.so\.1:$1$crosslibn32/ld.so.1:g;
+			} elsif ($multiarch =~ m/^mips(isa32)?.*-linux.*-gnu.*/) {
+				s:(^|[^-\w/])(/usr)?/lib/${multiarch}ld\.so\.1:$1$crosslib/ld.so.1:g;
+			} elsif ($multiarchtriplet eq "sparc64-linux-gnu") {
+				s:(^|[^-\w/])(/usr)?/lib/${multiarch}ld-linux\.so\.2:$1$crosslib64/ld-linux.so.2:g;
+			}
 			s:(^|[^-\w/])(/usr)?/lib/$multiarch:$1$crosslib/:g;
 			unless ($multiarch) {
 				s:(^|[^-\w/])(/usr)?/lib32/:$1$crosslib32/:g;
@@ -744,6 +753,35 @@
 		close(TO);
 		return 1;
 	}
+	# Helper: fix shlibs file
+	# - arch-qualify dependencies
+	sub fix_shlibs($$) {
+		my ($from, $to) = @_;
+		ensure_dir($to) or return 0;
+		if (! open(FROM, $from)) {
+			$msg = sprintf(_g("%s: failed to open %s: %s\n"), $progname, $from, $!);
+			warn ($msg);
+			return 0;
+		}
+		if (! open(TO, ">$to")) {
+			$msg = sprintf(_g("%s: failed to open %s for writing: %s\n"), $progname, $to, $!);
+			warn ($msg);
+			close(FROM);
+			return 0;
+		}
+		while (<FROM>) {
+			if (m/^#/) {
+				print TO;
+			} elsif (m/((?:\S+:\s*)?\S+\s+\S+\s+)(.*)/) {
+				print TO ($1 . join(",", map { s/\S+/$&:$arch/; $_; } split(/,/, $2)) . "\n");
+			} else {
+				print TO;
+			}
+		}
+		close(FROM);
+		close(TO);
+		return 1;
+	}
 	my $config = &get_config;
 	$crosstype = `CC="" dpkg-architecture -f -a$arch -qDEB_HOST_GNU_TYPE 2> /dev/null`;
 	chomp ($crosstype);
@@ -1018,7 +1056,12 @@
 
 		# Skip links that are going to point to themselves
 		next if ($lv eq $_);
-
+		
+		# skip /usr/$(multiarch)/lib/ld.so.1 for mips n32 and 64.
+ 		# their ld.so.1 should be in lib32 and lib64.
+		next if ($multiarch =~ m/^mips(isa)?64/ && $_ =~ m:lib/ld\.so\.1$:);
+		next if ($multiarchtriplet eq "sparc64-linux-gnu" && $_ =~ m:lib/ld-linux\.so\.2$:);
+		
 		# skip links to private modules and plugins that are not
 		# useful or packaged in the -cross package, basically anything
 		# in a directory beneath /usr/lib/. See #499292
@@ -1089,7 +1132,7 @@
 	# Link the shlibs file
 	if (-f "$src/DEBIAN/shlibs") {
 		print "Installing shlibs file\n" if $verbose >= 2;
-		link_file("$src/DEBIAN/shlibs", "$dst/DEBIAN/shlibs");
+		fix_shlibs("$src/DEBIAN/shlibs", "$dst/DEBIAN/shlibs");
 	}
 
 	# Create the control file.
